<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined('_JEXEC') or die( 'Restricted access' );
	jimport('joomla.application.component.controller');
	jimport( 'joomla.application.component.helper' );
	jimport('joomla.filesystem.file');

	class TPshowcaseController extends JController{
		function __construct(){
			parent::__construct();
		}
	
		function display(){
			$view 		= JRequest::getVar('view', null, 'default', 'cmd');
			$layout 	= JRequest::getVar('layout', null, 'default', 'cmd');
			/*
			echo $view;
			echo $layout;
			exit();
			*/
			if($view == 'list'){
				if($layout == 'thumbnail'){
					$model		= &$this->getModel('Thumbnail');
					$viewname	= &$this->getView($view, "html");
					$viewname->setModel($model, true);
					parent::display();
				}else if($layout == 'tags'){
					$model		= &$this->getModel('Thumbnails');
					$viewname	= &$this->getView($view, "html");
					$viewname->setModel($model, true);
					$viewname->setLayout('thumbnail_tags');
					$viewname->display();
				}else{
					$model		= &$this->getModel('Detail');
					$viewname	= &$this->getView($view, "html");
					$viewname->setModel($model, true);
					$viewname->setLayout('thumbnail_detail');
					$viewname->display();
				}
			}else if($view == 'vote'){
				$this->vote();
			}else{
				parent::display();
			}
		}
		
		function vote(){
			global $mainframe;
			$db			= &JFactory::getDBO();
			$user		= &JFactory::getUser();
			$params		= JComponentHelper::getParams( 'com_tpshowcase' );
			$uservote	= str_replace("/",DS,$params->get('uservote'));
			$id			= JRequest::getString('id', '', 'request');
			$ip			= $_SERVER['REMOTE_ADDR'];
			$var		= "";
			
			if($params->get('uservote') == true || $user->id > 0){
				//check ip
				$q		= "SELECT COUNT(showcase_id) AS total FROM #__tpshowcase_rating WHERE showcase_id=" . $db->Quote($id) . " AND lastip=" . $db->Quote($ip);
				$db->setQuery($q);
				$check	= $db->loadResult();
				
				if($check > 0){
					//already vote
					$q		= "SELECT COUNT(showcase_id) AS total FROM #__tpshowcase_rating WHERE showcase_id=" . $db->Quote($id);
					$db->setQuery($q);
					$total	= $db->loadResult();
					/*$var  .= "<script language=\"javascript\" type=\"text/javascript\">$$('#tpshowcase_warning span.msg1').setHTML('" . JText::_("TP_YOU_ALREADY_VOTE") . "');</script>";*/
					$var 	.= $total;
				}else{
					//save
					$q		= "INSERT INTO #__tpshowcase_rating(showcase_id,total,lastip) VALUES('$id','1','$ip')";
					$db->setQuery($q);
					$db->Query();
					
					//recalculate
					$q		= "SELECT COUNT(showcase_id) AS total FROM #__tpshowcase_rating WHERE showcase_id=" . $db->Quote($id);
					$db->setQuery($q);
					$total	= $db->loadResult();
					
					//update
					$q		= "UPDATE #__tpshowcase_rating SET total='$total' WHERE showcase_id=" . $db->Quote($id);
					$db->setQuery($q);
					$db->Query();
					$var	.= "<script language=\"javascript\" type=\"text/javascript\">$$('#tpshowcase_warning').setHTML('" . JText::_("TP_VOTE_SUCCESS") . "'); $('tpshowcase_warning').setStyle('display','');</script>";
					$var	.= $total;
				}
			}else{
				$q		= "SELECT COUNT(showcase_id) AS total FROM #__tpshowcase_rating WHERE showcase_id=" . $db->Quote($id);
				$db->setQuery($q);
				$total	= $db->loadResult();
				
				/*$var  .= "<script language=\"javascript\" type=\"text/javascript\">$$('#tpshowcase_warning span.msg3').setHTML('" . JText::_("TP_VOTE_LOGIN") . "');</script>";*/
				$var	.= $total;
			}
			echo $var;
			exit();
		}
		
		function save_site(){
			global $mainframe;
			JRequest::checkToken('request') or jexit( 'Invalid Token' );
			$params				= JComponentHelper::getParams( 'com_tpshowcase' );
			$pathtosave			= str_replace("/",DS,$params->get('pathtosave'));
			$pathtosave			= JPATH_SITE . DS . $pathtosave . DS;
			
			$db					=& JFactory::getDBO();
			$name				= JRequest::getString('name', '', 'request');
			$email				= JRequest::getString('email', '', 'request');
			$url				= JRequest::getString('url', '', 'request');
			$title				= JRequest::getString('title', '', 'request');
			$desc				= JRequest::getString('desc', '', 'request');
			$thumb				= JRequest::getVar('thumb', '', 'files', 'thumb');
			$screen				= JRequest::getVar('screen', '', 'files', 'screen');
			$tags				= JRequest::getString('tags', '', 'request');
			$status				= 0;
			$date				= date("Y-m-d H:i:s");
			$thumb['name']		= &JFile::makeSafe($thumb['name']); //make safe
			$screen['name']		= &JFile::makeSafe($screen['name']); //make safe
			
			if((!isset($thumb['name']) || $thumb['name'] == "")){
				$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_('TP_ERROR_THUMB'));
				return false;
			}
			
			if((!isset($screen['name']) || $screen['name'] == "")){
				$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_('TP_ERROR_SCREEN'));
				return false;
			}
			
			if(!$tags){
				$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_('TP_ERROR_TAGS'));
				return false;
			}
			
			$filepaththumb	= JPath::clean($pathtosave.strtolower($thumb['name']));
			$filepathscreen	= JPath::clean($pathtosave.strtolower($screen['name']));
				
			if((isset($thumb['name']) && $thumb['name'] != "") && !$this->canUpload( $thumb, $err )){
				$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_($err));
				return false;
			}
			
			if((isset($screen['name']) && $screen['name'] != "") && !$this->canUpload( $screen, $err )){
				$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_($err));
				return false;
			}
			
			//thumb
			if($thumb['name'] != ""){
				$newthumbname		= str_replace(".gif", "", $thumb['name']);
				$newthumbname		= str_replace(".jpg", "", $newthumbname);
				$newthumbname		= str_replace(".jpeg", "", $newthumbname);
				$newthumbname		= str_replace(".png", "", $newthumbname);
				$newthumbname		= str_replace(".", "", $newthumbname);
				$newthumbname		= str_replace(" ", "", $newthumbname);
				$newthumbname		= str_replace("-", "", $newthumbname);
				$newthumbname		= "thumb_" . strtolower(date('dMY_His')) . "_" . strtolower($newthumbname); //thumb_ + date + hour + original filename
				$uploadedthumb		= $thumb['tmp_name'];
				if($thumb['type'] == "image/gif"){
					$newthumbname		= $newthumbname . ".gif";
				}else if($thumb['type'] == "image/png"){
					$newthumbname		= $newthumbname . ".png";
				}else if($thumb['type'] == "image/jpg" || $thumb['type'] == "image/jpeg"){
					$newthumbname		= $newthumbname . ".jpg";
				}else{
					$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_('TP_ERROR_FILEEXT_NOTVALID'));
					return false;
				}
				
				$newfilepath_thumb	= JPath::clean($pathtosave.strtolower($newthumbname));
				JFile::move($thumb['tmp_name'], $newfilepath_thumb);
				@rename($filepaththumb, $newfilepath_thumb); // renamefile
				@chmod($newfilepath_thumb, 0755); // change chmod
			}
			
			//screen
			if($screen['name'] != ""){
				$newscreenname		= str_replace(".gif", "", $screen['name']);
				$newscreenname		= str_replace(".jpg", "", $newscreenname);
				$newscreenname		= str_replace(".jpeg", "", $newscreenname);
				$newscreenname		= str_replace(".png", "", $newscreenname);
				$newscreenname		= str_replace(".", "", $newscreenname);
				$newscreenname		= str_replace(" ", "", $newscreenname);
				$newscreenname		= str_replace("-", "", $newscreenname);
				$newscreenname		= "screen_" . strtolower(date('dMY_His')) . "_" . strtolower($newscreenname); //screen_ + date + hour + original filename
				$uploadedscreen		= $screen['tmp_name'];
				if($screen['type'] == "image/gif"){
					$newscreenname		= $newscreenname . ".gif";
				}else if($screen['type'] == "image/png"){
					$newscreenname		= $newscreenname . ".png";
				}else if($screen['type'] == "image/jpg" || $screen['type'] == "image/jpeg"){
					$newscreenname		= $newscreenname . ".jpg";
				}else{
					$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_('TP_ERROR_FILEEXT_NOTVALID'));
					return false;
				}
				
				$newfilepath_screen	= JPath::clean($pathtosave.strtolower($newscreenname));
				JFile::move($screen['tmp_name'], $newfilepath_screen);
				@rename($filepathscreen, $newfilepath_screen); // renamefile
				@chmod($newfilepath_screen, 0755); // change chmod
			}
										
			//save to database
			$q	= 	"INSERT INTO #__tpshowcase_showcase VALUES('','$name','$email','$url','$title','$newthumbname','$newscreenname','$desc','$tags','$date','$status')";
			$db->setQuery($q);
			$db->Query();
			$mainframe->redirect($_SERVER['HTTP_REFERER'], JText::_("TP_SUBMIT_SUCCESS"));
		}
		
		function canUpload( $file, &$err ){
			jimport('joomla.filesystem.file');
			if($file['name'] !== JFile::makesafe($file['name'])){
				$err = JText::_('TP_ERROR_FILENAME_NOTVALID!');
				return false;
			}
			
			$format = strtolower(JFile::getExt($file['name']));
	
			$allowable = explode( ',', "gif,jpg,jpeg,png");
			$ignored = explode(',', "bmp,exe,doc,zip,rar,xls,swf,html,html,php,asp,ppt,bat,pdf");
			if(!in_array($format, $allowable) && !in_array($format,$ignored)){
				$err = JText::_('TP_ERROR_FILEEXT_NOTVALID');
				return false;
			}
	
			$maxSize = 1000000; //max 1MB
			if($maxSize > 0 && (int) $file['size'] > $maxSize){
				$err = JText::_('TP_ERROR_FILEMAXSIZE_NOTVALID');
				return false;
			}
	
			$imginfo = null;
			if(true){
				$images = explode( ',', "gif,jpg,jpeg,png");
				if(($imginfo = getimagesize($file['tmp_name'])) === FALSE){
					$err = JText::_('TP_ERROR_FILENAME_NOTVALID');
					return false;
				}
			}
	
			$xss_check =  JFile::read($file['tmp_name'],false,256);
			$html_tags = array('abbr','acronym','address','applet','area','audioscope','base','basefont','bdo','bgsound','big','blackface','blink','blockquote','body','bq','br','button','caption','center','cite','code','col','colgroup','comment','custom','dd','del','dfn','dir','div','dl','dt','em','embed','fieldset','fn','font','form','frame','frameset','h1','h2','h3','h4','h5','h6','head','hr','html','iframe','ilayer','img','input','ins','isindex','keygen','kbd','label','layer','legend','li','limittext','link','listing','map','marquee','menu','meta','multicol','nobr','noembed','noframes','noscript','nosmartquotes','object','ol','optgroup','option','param','plaintext','pre','rt','ruby','s','samp','script','select','server','shadow','sidebar','small','spacer','span','strike','strong','style','sub','sup','table','tbody','td','textarea','tfoot','th','thead','title','tr','tt','ul','var','wbr','xml','xmp','!DOCTYPE', '!--');
			foreach($html_tags as $tag){
				// A tag is '<tagname ', so we need to add < and a space or '<tagname>'
				if(stristr($xss_check, '<'.$tag.' ') || stristr($xss_check, '<'.$tag.'>')){
					$err = 'WARNIEXSS';
					return false;
				}
			}
			return true;
		}
	}
?>