<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined( '_JEXEC' ) or die( 'Restricted access' );
	jimport( 'joomla.application.component.view');

	class TPshowcaseViewList extends JView{
		function display( $tpl = null){
			global $mainframe, $options;
	
			$layout	= $this->getLayout();
			if( $layout == 'thumbnail'){
				$this->_displayThumbs($tpl);
				return;
			}else if( $layout == 'thumbnail_tags'){
				$this->_displayTags($tpl);
				return;
			}else if( $layout == 'thumbnail_detail'){
				$this->_displayDetail($tpl);
				return;
			}
			
			$user 		=& JFactory::getUser();
			$params 	= &$mainframe->getParams();
			$menus		= &JSite::getMenu();
			$menu		= $menus->getActive();
	
			if(is_object( $menu )){
				$menu_params = new JParameter( $menu->params );
				if(!$menu_params->get( 'page_title')){
					$params->set('page_title',	JText::_( 'List' ));
				}
			}else{
				$params->set('page_title',	JText::_( 'List' ));
			}
			$document	= &JFactory::getDocument();
			$document->setTitle( $params->get( 'page_title' ) );
	
			$this->assignRef('params', 		$params);
			parent::display($tpl);
		}
		
		function _displayThumbs($tpl = null){
			global $mainframe, $options;
			jimport('joomla.html.pagination');
			
			$uri					=& JFactory::getURI();
			$document				=& JFactory::getDocument();
			$pparams				= &$mainframe->getParams('com_tpshowcase');
			$model					= &$this->getModel("Thumbnail");
			$limitstart				= JRequest::getVar('limitstart', 0, '', 'int');
			$default_limit 			= $pparams->def('display_num', $pparams->get('listlength'));
			$limit 					= $mainframe->getUserStateFromRequest('com_tpshowcase.'.$this->getLayout().'.limit', 'limit', $default_limit, 'int');
			$options['limit']		= $limit;
			$options['limitstart']	= $limitstart;
			$thumbnails				= $model->getThumbnail($options);
			$total 					= $model->getthumbnailCount($options);
			$menus					= &JSite::getMenu();
			$menu					= $menus->getActive();
			$pagination				= new JPagination($total, $limitstart, $limit);
				
			if(is_object( $menu )){
				$menu_params = new JParameter( $menu->params );
				if(!$menu_params->get( 'page_title')){
					$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
				}
			}else{
				$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
			}
			$document->setTitle( $pparams->get( 'page_title' ) );
			
			$this->assignRef('total',		$total);
			$this->assignRef('items',		$thumbnails);
			$this->assignRef('pagination',	$pagination);
			$this->assignRef('params',		$pparams);
			$this->assign('action',		$uri->toString());
			
			parent::display($tpl);
		}
		
		function _displayTags($tpl = null){
			global $mainframe, $options;
			jimport('joomla.html.pagination');
			
			$uri					=& JFactory::getURI();
			$document				=& JFactory::getDocument();
			$pparams				= &$mainframe->getParams('com_tpshowcase');
			$layout					= $this->getLayout();
			
			$model					= &$this->getModel("Thumbnails");
			$limitstart				= JRequest::getVar('limitstart', 0, '', 'int');
			$default_limit 			= $pparams->def('display_num', $pparams->get('listlength'));
			$limit 					= $mainframe->getUserStateFromRequest('com_tpshowcase.'.$this->getLayout().'.limit', 'limit', $default_limit, 'int');
			$options['limit']		= $limit;
			$options['limitstart']	= $limitstart;
			$thumbnails				= $model->getThumbnails($options);
			$total 					= $model->getthumbnailsCount($options);
			$menus					= &JSite::getMenu();
			$menu					= $menus->getActive();
			$pagination				= new JPagination($total, $limitstart, $limit);
				
			if(is_object( $menu )){
				$menu_params = new JParameter( $menu->params );
				if(!$menu_params->get( 'page_title')){
					$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
				}
			}else{
				$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
			}
			$document->setTitle( $pparams->get( 'page_title' ) );
			
			$this->assignRef('total',		$total);
			$this->assignRef('items',		$thumbnails);
			$this->assignRef('pagination',	$pagination);
			$this->assignRef('params',		$pparams);
			$this->assign('action',		$uri->toString());
			
			parent::display($tpl);
		}
		
		function _displayDetail($tpl = null){
			global $mainframe, $options;
			
			$document				=& JFactory::getDocument();
			$pparams				= &$mainframe->getParams('com_tpshowcase');
			$model					= &$this->getModel("Detail");
			$detail					= $model->getDetail($options);
			$menus					= &JSite::getMenu();
			$menu					= $menus->getActive();
	
			if(is_object( $menu )){
				$menu_params = new JParameter( $menu->params );
				if(!$menu_params->get( 'page_title')){
					$pparams->set('page_title',	JText::_( 'Showcase Detail' ));
				}
			}else{
				$pparams->set('page_title',	JText::_( 'Showcase Detail' ));
			}
			$document->setTitle( $pparams->get( 'page_title' ) );
			
			$this->assignRef('items',			$detail);
			$this->assignRef('params',			$pparams);
			parent::display($tpl);
		}
		
		function _displaySearch($tpl = null){
			global $mainframe, $options;
			jimport('joomla.html.pagination');
			
			$uri					=& JFactory::getURI();
			$document				=& JFactory::getDocument();
			$pparams				= &$mainframe->getParams('com_tpshowcase');
			$model					= &$this->getModel("Thumbnails");
			$limitstart				= JRequest::getVar('limitstart', 0, '', 'int');
			$default_limit 			= $pparams->def('display_num', $pparams->get('listlength'));
			$limit 					= $mainframe->getUserStateFromRequest('com_tpshowcase.'.$this->getLayout().'.limit', 'limit', $default_limit, 'int');
			$options['limit']		= $limit;
			$options['limitstart']	= $limitstart;
			$thumbnails				= $model->getThumbnails($options);
			$total 					= $model->getthumbnailsCount($options);
			$menus					= &JSite::getMenu();
			$menu					= $menus->getActive();
			$pagination				= new JPagination($total, $limitstart, $limit);
	
			if(is_object( $menu )){
				$menu_params = new JParameter( $menu->params );
				if(!$menu_params->get( 'page_title')){
					$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
				}
			}else{
				$pparams->set('page_title',	JText::_( 'Showcase Plazza' ));
			}
			$document->setTitle( $pparams->get( 'page_title' ) );
			
			$this->assignRef('total',		$total);
			$this->assignRef('items',		$thumbnails);
			$this->assignRef('pagination',	$pagination);
			$this->assignRef('params',		$pparams);
			$this->assign('action',		$uri->toString());
			parent::display($tpl);
		}
	}
?>