<?php
/**
* CSS TemplatePlazza Grid Rendering 
* TemplatePlazza.com 
**/

	$tpwidth_full		= $_GET['var1'];
	$tpwidth_gutter		= $_GET['var2'];
	$tpwidth_col		= $_GET['var3'];
	$tpwidth_colw		= $_GET['var4'];
	$tpwidth_content	= $_GET['var5'];
	
	$stylesheet = @is_file($_GET['stylesheet']) && strtolower(substr(strrchr($file_name,'.'),1)) == 'css' ? $_GET['stylesheet'] : 'grids.css';
		
	/* set the header information */
	header('Content-type: text/css');
	$days_to_cache = 10;
	header('Expires: '.gmdate('D, d M Y H:i:s',time() + (60 * 60 * 24 * $days_to_cache)).' GMT');
	
	//default css variable information
	$default = array(
		'tpwidth_full' 		=> $tpwidth_full."px",
		'tpwidth_gutter'	=> $tpwidth_gutter."px",
		'tpwidth_col'		=> $tpwidth_col."px",
		'tpwidth_colw'		=> $tpwidth_colw."px",
		'tpwidth_content'	=> ($tpwidth_content-10)."px",
		'grid_2'			=> (($tpwidth_colw*2)+($tpwidth_gutter*1)-10)."px",
		'grid_3'			=> (($tpwidth_colw*3)+($tpwidth_gutter*2)-10)."px",
		'grid_4'			=> (($tpwidth_colw*4)+($tpwidth_gutter*3)-10)."px",
		'grid_5'			=> (($tpwidth_colw*5)+($tpwidth_gutter*4)-10)."px",
		'grid_6'			=> (($tpwidth_colw*6)+($tpwidth_gutter*5)-10)."px",
		'grid_7'			=> (($tpwidth_colw*7)+($tpwidth_gutter*6)-10)."px",
		'grid_8'			=> (($tpwidth_colw*8)+($tpwidth_gutter*7)-10)."px",
		'grid_9'			=> (($tpwidth_colw*9)+($tpwidth_gutter*8)-10)."px",
		'grid_10'			=> (($tpwidth_colw*10)+($tpwidth_gutter*9)-10)."px",
		'grid_11'			=> (($tpwidth_colw*11)+($tpwidth_gutter*10)-10)."px",
		'grid_12'			=> (($tpwidth_colw*12)+($tpwidth_gutter*11)-10)."px",
		'grid_13'			=> (($tpwidth_colw*13)+($tpwidth_gutter*12)-10)."px",
		'grid_14'			=> (($tpwidth_colw*14)+($tpwidth_gutter*13)-10)."px",
		'grid_15'			=> (($tpwidth_colw*15)+($tpwidth_gutter*14)-10)."px",
		'fix_1'				=> (($tpwidth_colw+$tpwidth_gutter)*1)."px",
		'fix_2'				=> (($tpwidth_colw+$tpwidth_gutter)*2)."px",
		'fix_3'				=> (($tpwidth_colw+$tpwidth_gutter)*3)."px",
		'fix_4'				=> (($tpwidth_colw+$tpwidth_gutter)*4)."px",
		'fix_5'				=> (($tpwidth_colw+$tpwidth_gutter)*5)."px",
		'fix_6'				=> (($tpwidth_colw+$tpwidth_gutter)*6)."px",
		'fix_7'				=> (($tpwidth_colw+$tpwidth_gutter)*7)."px",
		'fix_8'				=> (($tpwidth_colw+$tpwidth_gutter)*8)."px",
		'fix_9'				=> (($tpwidth_colw+$tpwidth_gutter)*9)."px",
		'fix_10'			=> (($tpwidth_colw+$tpwidth_gutter)*10)."px",
		'fix_11'			=> (($tpwidth_colw+$tpwidth_gutter)*11)."px",
		'fix_12'			=> (($tpwidth_colw+$tpwidth_gutter)*12)."px",
		'fix_13'			=> (($tpwidth_colw+$tpwidth_gutter)*13)."px",
		'fix_14'			=> (($tpwidth_colw+$tpwidth_gutter)*14)."px",
		'fix_15'			=> (($tpwidth_colw+$tpwidth_gutter)*15)."px",
		'shadowlr'			=> ($tpwidth_full+20)."px",
		'shadowlrie'		=> ($tpwidth_full+14)."px"
	);
	
	//red css variable information
	/*
	$red = array(
		'body_font_size' => '10px',
		'body_text_color' => '#f00'
	);
	*/
	extract($_GET['theme'] && ${$_GET['theme']} ? ${$_GET['theme']} : $default);
	echo preg_replace('/\$([\w]+)/e','$0',@file_get_contents($stylesheet));
?>