<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined( '_JEXEC' ) or die( 'Restricted access' );
	jimport( 'joomla.application.component.controller' );
	jimport('joomla.filesystem.file');

	class TPshowcaseControllerShowcases extends JController{
		function __construct( $config = array() ){
			parent::__construct( $config );
			$this->registerTask( 'add',	'edit' );
		}
		
		function display($view = ''){
			$type = JRequest::getVar( 'type' );
			if(isset($type) && $type != ""){
				JRequest::setVar( 'view', $type );
			}
			parent::display();
		}
		
		function edit(){
			JRequest::setVar( 'view', 'showcase' );
			JRequest::setVar('hidemainmenu', 1);
			parent::display();
		}
		
		function publish(){
			$db		=& JFactory::getDBO();
			$cids 	= JRequest::getVar( 'bid', array(0), 'post', 'array' );
			if(count( $cids )){
				foreach($cids as $cid){
					$query		= "UPDATE #__tpshowcase_showcase SET status='1' WHERE id=" . $db->Quote($cid);
					$db->setQuery($query);
					$db->Query();
				}						
			}
			$this->setRedirect( 'index.php?option=com_tpshowcase&type=showcases', $msg );
		}
		
		function unpublish(){
			$db		=& JFactory::getDBO();
			$cids 	= JRequest::getVar( 'bid', array(0), 'post', 'array' );
			if(count( $cids )){
				foreach($cids as $cid){
					$query		= "UPDATE #__tpshowcase_showcase SET status='0' WHERE id=" . $db->Quote($cid);
					$db->setQuery($query);
					$db->Query();
				}						
			}
			$this->setRedirect( 'index.php?option=com_tpshowcase&type=showcases', $msg );
		}
		
		function remove(){
			jimport( 'joomla.application.component.helper' );
			
			$db			=& JFactory::getDBO();
			$cids 		= JRequest::getVar( 'bid', array(0), 'post', 'array' );
			$params		= JComponentHelper::getParams( 'com_tpshowcase' );
			$pathtosave	= str_replace("/",DS,$params->get('pathtosave'));
			$path		= JPATH_SITE . DS . $pathtosave . DS;
			
			if(count( $cids )){
				foreach($cids as $cid){
					//delete file
					$query	= "SELECT filename_thumb, filename_screen FROM #__tpshowcase_showcase WHERE id=" . $db->Quote($cid);
					$db->setQuery($query);
					$olds	= $db->loadObject();
					JFILE::delete(JPath::clean($path.strtolower($olds->filename_thumb))); //thumb
					JFILE::delete(JPath::clean($path.strtolower($olds->filename_screen))); //screen
					
					//delete rating
					$query		= "DELETE FROM #__tpshowcase_rating WHERE showcase_id=" . $db->Quote($cid);
					$db->setQuery($query);
					$db->Query();
					
					//delete db
					$query		= "DELETE FROM #__tpshowcase_showcase WHERE id=" . $db->Quote($cid);
					$db->setQuery($query);
					$db->Query();
				}						
			}
			$this->setRedirect( 'index.php?option=com_tpshowcase&type=showcases', $msg );
		}
	}
?>