<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined( '_JEXEC' ) or die( 'Restricted access' );

	class TPshowcaseControllerTag extends JController{
		function __construct( $config = array() ){
			parent::__construct( $config );
			$this->registerTask( 'add',	'edit' );
		}
		
		function display($view = ''){
			$type = JRequest::getVar( 'type' );
			if(isset($type) && $type != ""){
				JRequest::setVar( 'view', $type );
			}
			parent::display();
		}
		
		function edit(){
			JRequest::setVar( 'view', 'tag' );
			JRequest::setVar('hidemainmenu', 1);
			parent::display();
		}
		
		function cancel(){
			$this->setRedirect( 'index.php?option=com_tpshowcase&type=tags' );
		}
		
		function save(){
			$model = $this->getModel('tag');
	
			if ($model->store($post)) {
				$msg = JText::_( 'Data has been saved successfully!' );
			}else{
				$msg  = JText::_( 'Error saving data' );
				$msg .= ". " . JText::_('TP_SAVED_FAIL_EXIST_TAG');
			}
	
			$link = 'index.php?option=com_tpshowcase&type=tags';
			$this->setRedirect($link, $msg);
		}
	}
?>