<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined('_JEXEC') or die;
	jimport( 'joomla.application.component.model' );

	class TPshowcaseModelShowcases extends JModel{
		function getShowcases(){
			global $mainframe;
			$db	=& JFactory::getDBO();
			
			$limit				= $mainframe->getUserStateFromRequest( 'global.list.limit',	'limit', $mainframe->getCfg('list_limit'), 'int' );
			$limitstart			= $mainframe->getUserStateFromRequest( 'com_tpshowcase.limitstart', 'limitstart', 0, 'int' );

			// get the total number of records
			$query = "SELECT COUNT(*) FROM #__tpshowcase_showcase";
			$db->setQuery( $query );
			$total = $db->loadResult();
			
			jimport( 'joomla.html.pagination' );
			$pageNav = new JPagination( $total, $limitstart, $limit );
			
			$o	=	$this->getOrder();
			$q	=	"SELECT *, DATE_FORMAT(date, '%d %b %y - %H:%i:%s') AS date ".
					'FROM #__tpshowcase_showcase '.
					'ORDER BY '. $o['order'] .
					' '. $o['order_Dir'];
			$db->setQuery( $q, $pageNav->limitstart, $pageNav->limit );
			
			return $db->loadObjectList();
		}
		
		function getOrder(){
			if(isset( $this->_order )){
				return $this->_order;
			}
			$o	= array();
			$o['order']		= JRequest::getString( 'filter_order', 'id' );
			$o['order_Dir']	= JRequest::getString( 'filter_order_Dir', 'asc' );
			$this->_order	= $o;
			return $this->_order;
		}
	}
?>