<?php
	/**
	* TemplatePlazza
	* TemplatePlazza.com 
	**/
	defined('_JEXEC') or die('Restricted access');
	class modTpShowcaseHelper{
		function getList(&$params){
			global $mainframe;

			$db			=& JFactory::getDBO();
			$modlimit	= $params->get('modlimit');
			$modtype	= $params->get('modtype');
			$limit		= ($modlimit > 0) ? "LIMIT 0, " . intval($modlimit) : "";
			if($modtype == 1){
				$query		= "SELECT *, DATE_FORMAT(date, '%d/%m/%y') AS date FROM #__tpshowcase_showcase WHERE status='1' ORDER BY id DESC $limit"; //latest
			}else if($modtype == 2){
				$query		= "SELECT DISTINCT a.*, DATE_FORMAT(a.date, '%d/%m/%y') AS date FROM #__tpshowcase_showcase AS a, #__tpshowcase_rating AS b WHERE a.status='1' AND a.id = b.showcase_id ORDER BY b.total DESC $limit"; //vote
			}else if($modtype == 3){
				$query		= "SELECT *, DATE_FORMAT(date, '%d/%m/%y') AS date FROM #__tpshowcase_showcase WHERE status='1' ORDER BY RAND() $limit"; //random
			}
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			return $rows;
		}
		
		function getListTag(&$params){
			global $mainframe;
	
			$db			=& JFactory::getDBO();
			$taglimit	= $params->get('taglimit');
			$tagshort	= $params->get('tagshort');
			$limit		= ($taglimit > 0) ? "LIMIT 0, " . intval($taglimit) : "";
			$query		= "SELECT name FROM #__tpshowcase_tag ORDER BY name $tagshort $limit";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
	
			$i		= 0;
			$lists	= array();
			foreach( $rows as $row ){
				$lists[$i]->items = $row->name;
				$i++;
			}
			return $lists;
		}
	}
?>
